/*According to Jemai1 on the design philosophy forum....

cos(angle) = Xstep
sin(angle) = Ystep


*/
turf/icon = 'test2.dmi'

var/mob/player

mob/verb/Fire()
	if(!isstarted)
		Start_Game()
		return
	if(!not_paused && !buffer)
		not_paused = 1
	new/obj/Projectile/Good(loc,angle,src)

mob/verb/Start()
	for(var/turf/Spawn/S in world)
		spawn() S.Initiate()


mob
	var
		angle = 270
		r_angle = 0
		rotating
	offset = 8
	radius = 16
	icon = 'player.dmi'

	proc/update_skin()
		winset(player,"level","text=\"Level: [level]\"")
		winset(player,"spores","text=\"Spores: [spores]/[spores_needed]\"")
		winset(player,"HP","text=\"HP: [HP]/100\"")
		winset(player,"score","text=\"Score: [score]\"")

	proc/Rotate(n as num)
		while(rotating)
			angle += n
			r_angle += n*-1
			if(angle > 360) angle %= 360
			if(angle < 0) angle = 360-(abs(angle))
			if(r_angle > 360) r_angle %= 360
			if(r_angle < 0) r_angle = 360-(abs(r_angle))
			var/I = 'player.dmi'
			I = turn(I,r_angle)
			icon = I
			sleep(world.tick_lag)

	Login()
		..()
		src << browse({"<font color=[rgb(255,255,255)]><body bgcolor="black">Welcome to Battle for the sandwhich! You are a sentient mold creature that has taken it's place on a leftover sandwich! Do you have what it takes to survive?<br><br>
Instructions:<br>
1) Rotate your spore cannon with the arrow keys<br>
2) Fire a spore with the spacebar<br>
3) Don't get hit by the enemy spores and defend your sandwich!<br><br>

Tips: Some enemy spores won't hit you if left alone. It's important to make sure you get the ones that will before the ones that won't!
<br><br>
Press space to begin the game<br><br>
Icons courtesy of <a href=http://www.molotov.nu/?page=graphics#Chess>this</a> website."},"window=instruct;size=350x350")

	New()
		..()
		loc = locate(7,7,1)
		player = src
		relocset()

	proc/SRo()
		rotating = null

	proc/RoW()
		rotating = 1
		Rotate(8)

	proc/RoE()
		rotating = 1
		Rotate(-8)

client/Move() return null


world/tick_lag = 0.5

obj/Projectile
	density = 1
	var
		x_step
		y_step
		speed = 5

	Spore
		icon = 'spore.dmi'
		radius = 12
		speed = 3
		var/damage = 10
		isenemy = 1
		var/score = 5
		Del()
			loc = null
			..()
		pix_bump(mob/M)
			loc = null
			if(ismob(M))
				Hurt(damage)
			else
				spore_death(src)
			..()

	Good
		icon = 'goodb.dmi'
		radius = 8
		speed = 6
		New()
			pixel_x += player.offset+(player.radius/2)
			pixel_y += player.offset+(player.radius/2)
			..()

	New(loc,angle,mob/M)
		owner = M
		x_step = (cos(angle))*speed
		y_step = (sin(angle))*speed
		..()
		if(!density) world << "HAX"
		Go()

	pix_bump(mob/M)
		spawn() ..()
		spawn() del(src)

	Pix_Bumped(mob/M)
		spawn() ..()
		spawn() del(src)

/*
10,10
3 ,3
*/


	collision_detect(tx,ty)
		if(!density) return
		for(var/atom/A in range(1,src)-src)
		//	world << "[A],[A.density],[A.pixx],[A.pixy],[A.radius]"
			if(!A.density || owner == A || (A.isenemy && isenemy) || owner == A.owner) continue
			var
				D = radius/2
				AD = A.radius/2
				XD = abs((A.pixx+AD)-((pixx+tx)+D)) //total X distance (from center)
				YD = abs((A.pixy+AD)-((pixy+ty)+D)) //total Y distance (from center)
				TD = sqrt(((XD*XD)+(YD*YD))) //pythagorean theorem time...the credit for this collision handling method goes to
											//whoever wrote that one dream makers article months ago >_>
			if(round(TD) < (AD+D))
				return A
		return 0

	proc/Go()
		for(src,x && y)
			. = pix_move(x_step,y_step)
			if(!.) return
			sleep(world.tick_lag)
		del(src)
atom
	var
		radius = 2
		pixx
		pixy
		offset
		isenemy
		owner

	proc/Pix_Bumped(mob/M)

	proc/relocset()
		pixx = (x-1)*32+pixel_x+offset
		pixy = (y-1)*32+pixel_y+offset

	New()
		..()
		relocset()

atom/movable

	animate_movement = NO_STEPS

	New()
		..()
		pixx = (x-1)*32
		pixy = (y-1)*32

	proc/pix_bump(atom/A)
		if(!A) return
		A.Pix_Bumped(src)

	relocset()
		..()
		if(pixel_x >= 32)
			spawn pixel_x = 0
			spawn loc = locate(x+1,y,z)
		if(pixel_y >= 32)
			spawn pixel_y = 0
			spawn loc = locate(x,y+1,z)
		if(pixel_x <= -32)
			spawn pixel_x = 0
			spawn loc = locate(x-1,y,z)
		if(pixel_y <= -32)
			spawn pixel_y = 0
			spawn loc = locate(x,y-1,z)
		..()


	proc/pix_move(tx,ty)
		. = collision_detect(tx,ty)
		if(.)
			pix_bump(.)
			return
		pixel_x += tx
		pixel_y += ty
		relocset()
		return 1

	proc/collision_detect(tx,ty)
		if(!density) return
		for(var/atom/A in range(1,src)-src)
			if(!A.density) continue
			if(A.offset) world << A.offset
			var
				D = radius/2
				AD = A.radius/2
				XD = abs(((pixx+tx)+D)-(A.pixx+AD+A.offset)) //total X distance (from center)
				YD = abs(((pixy+ty)+D)-(A.pixy+AD+A.offset)) //total Y distance (from center)
				TD = sqrt((XD*XD)+(YD*YD)) //pythagorean theorem time...the credit for this collision handling method goes to
											//whoever wrote that one dream makers article months ago >_>
			if(TD < (AD+D))
				return A
		return 0